using System;
using System.Collections.ObjectModel;

namespace Infragistics.Samples.Models
{
    public class DataSample : DataCollection
    {
        public DataSample()
        {
            double grade = 50;
            double speed = 20;
            DateTime date = new DateTime(2010, 1, 1, 12, 00, 00);
            for (int i = 0; i < 100; i++)
            {

                double change = DataGenerator.Random.NextDouble();
                if (change > .5)
                {
                    grade += (double)(change * 20);
                    speed += (double)(change * 5);
                }
                else
                {
                    grade -= (double)(change * 20);
                    speed -= (double)(change * 5);
                }

                this.Add(new DataPoint { Date = date, Grade = grade, Speed = speed });
                date = date.Add(TimeSpan.FromMinutes(5));
            }
        }
    }
    public static class DataGenerator
    {
        static DataGenerator ()
        {
            Random = new Random();
        }
        public static Random Random { get; private set; }
    }
    public class DataCollection : ObservableCollection<DataPoint>
    {

    }
    public class DataPoint : ObservableModel
    {
        #region Properties
        private double _grade;
        private DateTime _date;
        private double _speed;
        
        public double Grade
        {
            get { return _grade; } 
            set { if (_grade == value) return; _grade = value; OnPropertyChanged("Grade"); }
        }
        public DateTime Date
        {
            get { return _date; }
            set { if (_date == value) return; _date = value; OnPropertyChanged("Date"); }
        }
        public double Speed { get { return _speed; } set { if (_speed == value) return; _speed = value; OnPropertyChanged("Speed"); } }
        

        #endregion

         
    }
}